#!/usr/bin/env python3
#-*- coding: utf-8 -*-


import queue
import time
import threading
import logging
import csv
import json

_logger = logging.getLogger(__name__)

def createThread(task, args = ()):

    t = threading.Thread(target=task, args = args)
    t.setDaemon(True)
    t.start()
	
def Loop_prco(msgQueue):
    global runbFlag
    header = ['intervalTime']
    rows = []

    while(True):
        if(runbFlag == False):
            time.sleep(1)
            continue

        with open('./csvdir.csv', 'w+', newline='') as f:
            ff = csv.writer(f)
            ff.writerow(header)
            while(True):
                try:
                    msg = msgQueue.get(block=True, timeout=10)
                    event_json = json.loads(msg[1])
                    payload_json = json.loads(event_json["payload"])
	
	                # "currentTime":{"time":1574930195149,"value":1574930195149124}
                    srcTime = payload_json["currentTime"]["value"]
                    intervalTime = msg[0] - srcTime

                    if(len(rows) == 1000):
                        ff.writerows(rows)
                        rows = []
                    else:
                        rows.append([intervalTime,])
                
                except queue.Empty:
                    if(len(rows) != 0):
                        ff.writerows(rows)
                        rows = []
                    _logger.warning("queue empty")
                    runbFlag = False
                    break
                    
                except:
                    _logger.exception("Err")



msgQueue = queue.Queue(100 * 10000)
runbFlag = False

createThread(Loop_prco, (msgQueue, ))


'''
# event参数是您调用函数时传入的数据，其类型是Buffer。数据结构可由您自行定义，当消息来自设备时，数据结构如下：
# event: { "topic" : ${TOPIC}, "payload" : ${PAYLOAD} "provider" : { "groupId" : xxx } }
        # TOPIC 为一个字符串类型，首字母必须是"/"，格式：
                # 当数据来源为设备属性时候： "/sys/${PRODUCT}/${DEVICE_NAME}/thing/event/property/post"
                # 当数据来源为设备事件时候： "/sys/${PRODUCT}/${DEVICE_NAME}/thing/event/${EVENT}/post"

        #PAYLOAD 其类型是Object。#设备属性上报payload格式：
                #{ "Power":{ "value":"on", "time":1524448722000 }, "WF":{ "value": {}, "time":1524448722000 } }

        #设备事件上报payload格式：
                #{"params":{"value":{"Power":"on","WF":"2"},"time":1524448722000}}
'''

def handler(event, context):
    global  msgQueue, runbFlag
    _logger.warning("enter the handler")
    #if (_logger.isEnabledFor(logging.DEBUG)):
    #    _logger.debug(event)
		
    curTime = float(time.time() * 1000000)
    runbFlag = True
	
    try:
        msgQueue.put([curTime, event], block=False)
    except queue.Full:
        _logger.warning("queue full")
    
    except:
        _logger.exception("Err")
    
    _logger.warning("exit the handler")
