local json = require("json")
local const = require("const")
local utils = require("utils3")

utils.check_request_method("GET")
utils.check_auth()
utils.check_permission("TSLManage")

local product = ngx.var[1]
if not utils.is_valid_pk(product) then
    return utils.error_exit(
            ngx.HTTP_BAD_REQUEST,
            const.INVALID_PARAMETER,
            "invalid ProductKey: " .. product)
end

local ok, ret, err = utils.get_tsl(product)
if not ok then
    return utils.error_exit(ngx.HTTP_INTERNAL_SERVER_ERROR, ret, err)
end

local ok, tsl = pcall(json.decode, ret)
if not ok then
    return utils.error_exit(
            ngx.HTTP_INTERNAL_SERVER_ERROR,
            const.MESSAGE_INVALIDREPLY,
            "not a JSON")
end

local resp = {}
resp["Data"] = {}
resp["Data"]["TSL"] = tsl
local str = json.encode(resp)
ngx.header['Content-Type'] = 'application/json; charset=utf-8'
ngx.say(str)