local json = require("json")
local utils = require("utils")
local driver_utils = require("driver_utils")

local request_method = ngx.var.request_method

utils.check_login()
utils.check_permission("DeviceManage") 

if ("POST" == request_method) then 
    local utils_header = require("utils_header")
    local params = utils_header.check_public_body_data()
    local pk = params["ProductKey"]
    local dn = params["DeviceName"]
    local tags = params["DeviceTags"]

    if (not (pk and dn and tags)) then
        utils.error_exit(400, "invalid parameter")
    end

    if ("string" == type(tags)) then
        tags = {tags} -- convert to table type if @tags is a string type
    end

    if (tags and "" ~= tags) then    
        utils.set_device_tags(pk, dn, tags)
    end
    utils.error_exit(200, '{}')
end

utils.error_exit(400, "unsupported request method")
------ EOF ------
