# -*- coding: utf-8 -*-

import logging
import time
import lethingaccesssdk
from threading import Timer


class Light(lethingaccesssdk.BaseThing):
    def __init__(self, config):
        super(Light, self).__init__(config)
        self._isOn = 1

    @property
    def isOn(self):
        return self._isOn

    def setProperties(self, input):
        if 'LightSwitch' in input:
            value = input['LightSwitch']
            if value != self.isOn:
                self._isOn = value
            return 0, {}
        else:
            return 100001, {}

    def getProperties(self, input):
        return 0, {}

    def callService(self, name, input):
        return 0, {}


def thing_behavior(device):
    device.online()
    while True:
        properties = {"LightSwitch": device.isOn}
        device.reportProperties(properties)
        time.sleep(2)


try:
    thing_config = lethingaccesssdk.Config().getThingInfos()
    for config in thing_config:
        device = Light(config)
        t = Timer(2, thing_behavior, (device, ))
        t.start()

except Exception as e:
    logging.error(e)

# don't remove this function
def handler(event, context):
    return 'hello world'
